- Development Integration
- /
- SDK
- /
- Python
- /
Management Module
- /
User Management
- /
- Update User Profile
¶ Modify user information
Update time: 2025-07-23 07:34:21
This document is automatically generated based on https://github.com/authing/authing-docs-factory based on https://api-explorer.genauth.ai V3 API, and is consistent with API parameters and return results. If the document description is incorrect, please refer to V3 API.
Modify user information through user ID. Email, mobile number, user name, externalId are unique in the user pool. This interface will modify user information as an administrator, so there is no need to perform security checks such as mobile number verification code verification.
¶ Method name
ManagementClient.update_user
¶ Request parameters
| Name | Type | Required | Default value | Description | Sample value |
|---|---|---|---|---|---|
| userId | string | yes | - | The unique identifier of the user, which can be user ID, user name, email, mobile number, externalId, or ID in an external identity source. For details, see the description of the userIdType field. The default is user id. | 6229ffaxxxxxxxxcade3e3d9 |
| phoneCountryCode | string | no | - | Mobile phone area code. This field is optional for mobile phone numbers in mainland China. The GenAuth SMS service does not currently support international mobile phone numbers. You need to configure the corresponding international SMS service in the GenAuth console. For a complete list of mobile phone area codes, see https://en.wikipedia.org/wiki/List_of_country_calling_codes. | +86 |
| name | string | No | - | User's real name, not unique | xxx |
| nickname | string | No | - | Nickname | xxx |
| photo | string | No | - | Avatar link | https://files.authing.co/authing-console/default-user-avatar.png |
| externalId | string | No | - | Third-party external ID | 10010 |
| status | string | no | Activated | Current account status | Activated |
| emailVerified | boolean | no | - | Email verified | true |
| phoneVerified | boolean | no | - | Phone number verified | true |
| birthdate | string | no | - | Date of birth | 2022-06-03 |
| country | string | no | - | Country | CN |
| province | string | no | - | Province | BJ |
| city | string | no | - | City | BJ |
| address | string | no | - | Address | xxxxx |
| streetAddress | string | no | - | Street address | xxxxx |
| postalCode | string | no | - | Postal code | 438100 |
| gender | string | no | U | Gender | M |
| username | string | no | - | Username, unique in the user pool | bob |
| string | No | - | Email address, case-insensitive | test@example.com | |
| phone | string | No | - | Phone number without area code. If it is a foreign phone number, please specify the area code in the phoneCountryCode parameter. | 188xxxx8888 |
| password | string | No | - | User password, plain text by default. We use the HTTPS protocol to securely transmit passwords, which can ensure security to a certain extent. If you need a higher level of security, we also support RSA256 and SM2 to encrypt passwords. See the passwordEncryptType parameter for details. | passw0rd |
| company | string | no | - | Company | steamory |
| browser | string | no | - | Last login browser UA | Mozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0 |
| device | string | no | - | Last login device | iOS |
| givenName | string | no | - | First Name | xx |
| familyName | string | no | - | Last Name | xxx |
| middleName | string | no | - | Middle Name | James |
| profile | string | no | - | Preferred Username | alice |
| preferredUsername | string | no | - | Preferred Username | alice |
| website | string | no | - | User's personal website | https://my-website.com |
| zoneinfo | string | no | - | User's time zone information | GMT-08:00 |
| locale | string | No | - | Locale | af |
| formatted | string | No | - | Standard full address | 132, My Street, Kingston, New York 12401. |
| region | string | No | - | User's region | Xinjiang Uyghur Autonomous Region |
| identityNumber | string | No | - | User ID number | 420421xxxxxxxx1234 |
| customData | object | No | - | Custom data. The key in the passed object must first be defined in the user pool for the relevant custom fields | {"school":"xxxxx","age":22} |
| metadata | object | No | - | Data object data. The key in the passed object must first be defined in the user data object for the relevant custom fields | {"school":"xxxxx","age":22} |
| options | UpdateUserOptionsDto | No | - | Optional parameters | {"autoGeneratePassword":true,"resetPasswordOnFirstLogin":true,"passwordEncryptType":"none"} |
¶ Request Response
Type: UserSingleRespDto
| Name | Type | Description |
|---|---|---|
| statusCode | number | Business status code, which can be used to determine whether the operation is successful. 200 means success. |
| message | string | Description |
| apiCode | number | Segmented error code, which can be used to get the specific error type (no return for successful requests). For a detailed list of error codes, please see: API Code List (opens new window) |
| requestId | string | Request ID. Returned when the request fails. |
| data | UserDto | Response data |
Example results:
{
"statusCode": 200,
"message": "Success",
"requestId": "934108e5-9fbf-4d24-8da1-c330328abd6c",
"data": {
"userId": "6229ffaxxxxxxxxcade3e3d9",
"createdAt": "2022-07-03T03:20:30.000Z",
"updatedAt": "2022-07-03T03:20:30.000Z",
"status": "Activated",
"workStatus": "Active",
"externalId": "10010",
"email": "test@example.com",
"phone": "188xxxx8888",
"phoneCountryCode": "+86",
"username": "bob",
"name": "xxx",
"nickname": "xxx",
"photo": "https://files.authing.co/authing-console/default-user-avatar.png",
"loginsCount": 3,
"lastLogin": "2022-07-03T03:20:30.000Z",
"lastIp": "127.0.0.1",
"gender": "M",
"emailVerified": true,
"phoneVerified": true,
"passwordLastSetAt": "2022-07-03T03:20:30.000Z",
"birthdate": "2022-06-03",
"country": "CN",
"province": "BJ",
"city": "BJ",
"address": "xxxxx",
"streetAddress": "xxxxx",
"postalCode": "438100",
"company": "steamory",
"browser": "Mozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0",
"device": "iOS",
"givenName": "xx",
"familyName": "xxx",
"middleName": "James",
"profile": "alice",
"preferredUsername": "alice",
"website": "https://my-website.com",
"zoneinfo": "GMT-08:00",
"locale": "af",
"formatted": "132, My Street, Kingston, New York 12401.",
"region": "Xinjiang Uyghur Autonomous Region",
"userSourceType": "register",
"passwordSecurityLevel": 1,
"departmentIds": "[\"624d930c3xxxx5c08dd4986e\",\"624d93102xxxx012f33cd2fe\"]",
"identities": {
"identityId": "62299d8b866d2dab79a89dc4",
"extIdpId": "6076bacxxxxxxxxd80d993b5",
"provider": "wechat",
"type": "openid",
"userIdInIdp": "oj7Nq05R-RRaqak0_YlMLnnIwsvg",
"accessToken": "57_fK0xgSL_NwVlS-gmUwlMQ2N6AONNIOAYxxxx",
"refreshToken": "57_IZFu91Ak1Wg6DRytZFFIOd3upNF5lH7vPxxxxx",
"originConnIds": "[\"605492ac41xxxxe0362f0707\"]"
},
"identityNumber": "420421xxxxxxxx1234",
"customData": {
"school": "xxxxx",
"age": 22
},
"statusChangedAt": "2022-07-03T03:20:30.000Z"
}
}
¶ Data Structure
¶ UpdateUserOptionsDto
| Name | Type | Is this field required? | Description | Sample value |
|---|---|---|---|---|
| userIdType | string | No | User ID type, the default value is user_id, the optional values are:- user_id: GenAuth user ID, such as 6319a1504f3xxxxf214dd5b7- phone: user phone number- email: user email- username: username- external_id: user ID in the external system, corresponding to the externalId field of GenAuth user information- identity: user's external identity source information, in the format of <extIdpId>:<userIdInIdp>, where <extIdpId> is the ID of the GenAuth identity source, and <userIdInIdp> is the user's ID in the external identity source.Example value: 62f20932716fbcc10d966ee5:ou_8bae746eac07cd2564654140d2a9ac61.- sync_relation: The user's external identity source information, in the format of <provier>:<userIdInIdp>, where <provier> is the synchronization identity source type, such as wechatwork, lark; <userIdInIdp> is the user's ID in the external identity source.Example value: lark:ou_8bae746eac07cd2564654140d2a9ac61. | user_id |
| resetPasswordOnFirstLogin | boolean | no | Set the requirement to reset the password for the first login | |
| resetPasswordOnNextLogin | boolean | no | Require the password to be reset for the next login | |
| passwordEncryptType | string | no | Password encryption type, supports encryption using RSA256 and SM2 algorithms. The default is none, no encryption.- none: Do not encrypt the password, use plain text for transmission.- rsa: Use the RSA256 algorithm to encrypt the password, which requires the RSA public key of the GenAuth service. Please read the Introduction section to learn how to obtain the RSA256 public key of the GenAuth service.- sm2: Use National Encryption SM2 Algorithm (opens new window) to encrypt the password. You need to use the SM2 public key of the GenAuth service for encryption. Please read the Introduction section to learn how to obtain the SM2 public key of the GenAuth service. | sm2 |
| autoGeneratePassword | boolean | No | Whether to automatically generate a password | |
| sendPasswordResetedNotification | No | Option to send email and phone number when password is reset Nested type: SendResetPasswordNotificationDto. | {"sendDefaultEmailNotification":false,"sendDefaultPhoneNotification":false,"inputSendEmailNotification":"test@example.com","inputSendPhoneNotification":"136xxxx1234","appId":"app1"} |
¶ SendResetPasswordNotificationDto
| Name | Type | Is it required? | Description | Sample value |
|---|---|---|---|---|
| sendDefaultEmailNotification | boolean | No | After resetting the password, whether to send the user's default email notification | |
| sendDefaultPhoneNotification | boolean | No | After resetting the password, whether to send the user's default SMS notification | |
| inputSendEmailNotification | string | No | When the user's password is changed, enter the email address to send | test@example.com |
| inputSendPhoneNotification | string | No | When the user's password is changed, enter the mobile phone number to send | 183xxxx1234 |
| appId | string | No | When sending the login address, the specified application id will send the login address of this application to the user's email or mobile phone number. The default is the login address of the user pool application panel. | appid1 |
¶ UserDto
| Name | Type | Is it required | Description | Sample value |
|---|---|---|---|---|
| userId | string | Yes | The unique identifier of the user, which can be user ID, user name, email, phone number, externalId, or ID in an external identity source. For details, see the description of the userIdType field. The default is user id. | 6229ffaxxxxxxxxcade3e3d9 |
| createdAt | string | yes | creation time | 2022-07-03T03:20:30.000Z |
| updatedAt | string | yes | update time | 2022-07-03T03:20:30.000Z |
| status | string | yes | current status of the account: - Activated: normal status - Suspended: deactivated - Deactivated: disabled - Resigned: resigned - Archived: archived | Suspended |
| workStatus | string | yes | current work status of the account | Closed |
| externalId | string | no | third-party external ID | 10010 |
| string | no | email address, case insensitive | test@example.com | |
| phone | string | No | Phone number without area code. If it is an international phone number, please specify the area code in the phoneCountryCode parameter. | 188xxxx8888 |
| phoneCountryCode | string | No | Phone area code. This parameter is optional for phone numbers in mainland China. The GenAuth SMS service does not currently support international phone numbers. You need to configure the corresponding international SMS service in the GenAuth console. For a complete list of phone area codes, please refer to https://en.wikipedia.org/wiki/List_of_country_calling_codes. | +86 |
| username | string | No | Username, unique in the user pool | bob |
| name | string | no | User's real name, not unique | xxx |
| nickname | string | no | Nickname | xxx |
| photo | string | no | Avatar link | https://files.authing.co/authing-console/default-user-avatar.png |
| loginsCount | number | no | Total number of historical logins | 3 |
| lastLogin | string | no | Last login time | 2022-07-03T03:20:30.000Z |
| lastIp | string | no | Last login IP | 127.0.0.1 |
| gender | string | yes | Gender: - M: Male, male- F: Female, female- U: Unknown, unknown | M |
| emailVerified | boolean | yes | Is email verified? | true |
| phoneVerified | boolean | yes | Is phone number verified? | true |
| passwordLastSetAt | string | No | User's last password modification time | 2022-07-03T03:20:30.000Z |
| birthdate | string | No | Date of birth | 2022-06-03 |
| country | string | No | Country | CN |
| province | string | No | Province | BJ |
| city | string | No | City | BJ |
| address | string | No | Address | xxxxx |
| streetAddress | string | No | Street address | xxxxx |
| postalCode | string | No | Postal code | 438100 |
| company | string | no | Company | steamory |
| browser | string | no | Last login browser UA | Mozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0 |
| device | string | no | Last login device | iOS |
| givenName | string | no | First Name | xx |
| familyName | string | no | Last Name | xxx |
| middleName | string | no | Middle Name | James |
| profile | string | no | Preferred Username | alice |
| preferredUsername | string | no | Preferred Username | alice |
| website | string | No | User personal webpage | https://my-website.com |
| zoneinfo | string | No | User time zone information | GMT-08:00 |
| locale | string | No | Locale | af |
| formatted | string | No | Standard full address | 132, My Street, Kingston, New York 12401. |
| region | string | No | User's region | Xinjiang Uyghur Autonomous Region |
| userSourceType | string | Yes | Source type: - excel: Imported via excel- register: User self-registration- adminCreated: Manual creation by the administrator backend (including creating users using the management API)- syncTask: Sync task in the sync center | excel |
| userSourceId | string | No | Application ID or sync task ID | |
| lastLoginApp | string | No | Application ID of the user's last login | |
| mainDepartmentId | string | No | User's main department ID | |
| lastMfaTime | string | No | The last time the user performed MFA Authentication time | |
| passwordSecurityLevel | number | No | User password security strength level | 1 |
| resetPasswordOnNextLogin | boolean | No | Require password reset on next login | |
| registerSource | array | no | Registration method | |
| departmentIds | array | no | List of department IDs to which the user belongs | ["624d930c3xxxx5c08dd4986e","624d93102xxxx012f33cd2fe"] |
| identities | array | no | External identity source Nested type: IdentityDto. | |
| identityNumber | string | No | User ID number | 420421xxxxxxxx1234 |
| customData | object | No | User's extended field data | {"school":"xxxxx","age":22} |
| postIdList | array | No | User-associated department ID | |
| statusChangedAt | string | No | User status last modified time | 2022-07-03T03:20:30.000Z |
| tenantId | string | No | User tenant ID |
¶ IdentityDto
| Name | Type | Is this field required? | Description | Sample value |
|---|---|---|---|---|
| identityId | string | yes | Identity source ID | 62299d8b866d2dab79a89dc4 |
| extIdpId | string | yes | Identity source connection ID | 6076bacxxxxxxxxd80d993b5 |
| provider | string | yes | External identity source type: - wechat: WeChat- qq: QQ- wechatwork: WeChat for Business- dingtalk: DingTalk- weibo: Weibo- github: GitHub- alipay: Alipay- baidu: Baidu- lark: Feishu- welink: Welink- yidun: NetEase Yidun- qingcloud: Qingyun- google: Google- gitlab: GitLab- gitee: Gitee- twitter: Twitter- facebook: Facebook- slack: Slack- linkedin: Linkedin- instagram: Instagram- oidc: OIDC-based enterprise identity source- oauth2: OAuth2-based enterprise identity source- saml: SAML-based enterprise identity source- ldap: LDAP-based enterprise identity source- ad: AD-based enterprise identity source- cas: CAS-based enterprise identity source- azure-ad: Azure AD-based enterprise identity source | oidc |
| type | string | Yes | Identity type, such as unionid, openid, primary | openid |
| userIdInIdp | string | Yes | ID in external identity source | oj7Nq05R-RRaqak0_YlMLnnIwsvg |
| userInfoInIdp | object | Yes | User's identity information in idp | |
| accessToken | string | no | Access Token in the external identity source (this parameter is returned only when the user actively obtains it, and it is not returned by the management interface). | 57_fK0xgSL_NwVlS-gmUwlMQ2N6AONNIOAYxxxx |
| refreshToken | string | no | Refresh Token in the external identity source (this parameter is returned only when the user actively obtains it, and it is not returned by the management interface). | 57_IZFu91Ak1Wg6DRytZFFIOd3upNF5lH7vPxxxxx |
| originConnIds | array | yes | Identity source connection ID list from which the identity comes | ["605492ac41xxxxe0362f0707"] |
